;22 Feb 2015
ORG 0000H
LJMP MAIN
popByte  equ 40h


progBTN1  equ P3.3
progBTN2  equ P3.4
clockInput equ P3.1


BIT_VAR         equ   20h


progBit1     BIT     BIT_VAR.0         
progBit2     BIT     BIT_VAR.1
                                      



#include "program.inc"
MAIN:

	 mov BIT_VAR,#3 ;no button  pressed
	 mov P1,0
	
;check button pressed in delay routine
;delay routine records presses in progBit1 and progBit2

testButton1:
               	
				 mov A,BIT_VAR ;debug
				 ;mov P1,A
				 
              
		        jb progBit1,testButton2	    
				orl P1,#0x20  ;debug
                call program0  ;Run this segment if button pressed
                sjmp testButton1  ;done

testButton2:

              
				jb progBit2,default
				orl P1,#0x40  ;debug
                call program2  ;Run this segment if button pressed
                sjmp testButton1
default:  
                orl P1,#0x80  ;debug
                call program1  ;Run this segment if no buttons pressed
                sjmp testButton1



;;;;;delay
delay2:	 
     mov popByte,A   ;save A
  ;start by checking for changes to buttons
    mov A,#3
    ;read switches
    jb progBTN1,testxrl2
	xrl A,#1 ;bit low=  button 1 pressed
testxrl2:
    jb progBTN2,testend
	xrl A,#2   ;bit low= button 2 pressed
testend:
  
     xrl A,BIT_VAR	   ;compare to last known state
	 JNZ updateBits    ;jmp if something changed
  ;do delay as normal and return
  	
		
  ;software delay
   ;MOV R0,#0FFH
;INLOP:
    ;MOV R1,#0FFH	
;	DJNZ R1,$
	;DJNZ R0,INLOP
  ; mov A,popByte  ;return saved Acc
;	ret
	


;hardware delay

    JB clockInput,$ ;wait while high
    JNB clockInput,$ ;wait while  low
	mov A,popByte  ;return saved Acc
	ret



  ;mark the state of the buttons 
updateBits:
  
   mov BIT_VAR,#3  ;default,both bits high, nothing pressed	 
   jnb progBTN1,button1exit
   jnb progBTN2,button2exit
   sjmp popExit
   
button1exit:
   clr progBit1  ;show button pressed
   sjmp popExit
   
button2exit:
   clr progBit2  ;show button pressed
  
   
popExit:	;change stack to return to main loop and start new routine
   mov A,popByte  ;return saved A
   pop popByte ;dump high byte of return address
   pop popByte ;dump low byte
   pop popByte ;dump high
   pop popByte ;dump low
   ret

			
END 



